mundo = {}
mundo = {}
function mundo:add(x,y,nome_img,tipo,cor)
	self[#self+1] = {
		x=x,
		ini_x=x,
		y=y,
		ini_y=y,
		nome_img=nome_img,
		vel_x=0,
		tipo=tipo,
		dir="",
		exibe=0,
		img="",
		colisao_jogador=false,
		colisao_moeda=false,
		colisao=false,
		cor=cor,
		tempo_treme=0,
		tempo_explosao=0,
		tempo_cria_efeito=0,
		qtd_explosao=0,
		explodido=false
	}
	if nome_img~="limite" and nome_img~="img_ceu" and nome_img~="ballon" and nome_img~="lock" then
		self[#self].img=love.graphics.newImage("gfx/"..nome_img..".png")
		if string.find(nome_img,"cloud")~=nil then
			dir=math.random(-1,1)
			if dir==0 then	dir=1 end
			self[#self].vel_x=(math.random()/10)*dir
		end
		if nome_img=="plank" then
			if tipo=="vert" then self[#self].dir="up" end
			if tipo=="horz" then self[#self].dir="right" end
		end
	end
	if nome_img=="img_ceu" or string.find(nome_img,"cloud")~=nil then
		self[#self].exibe=4
	end
	if nome_img=="ballon" or nome_img=="lock" then
		self[#self].img=love.graphics.newImage("gfx/"..nome_img.."_"..cor..".png")
		if nome_img=="ballon" then
			self[#self].vel_x=.0025
			if cor=="green" then
				self[#self].tempo_treme=love.timer.getMicroTime()+2.5
			elseif cor=="blue" then
				self[#self].tempo_treme=love.timer.getMicroTime()+2
			elseif cor=="yellow" then
				self[#self].tempo_treme=love.timer.getMicroTime()+1.5
			elseif cor=="red" then
				self[#self].tempo_treme=love.timer.getMicroTime()+1
			end
		end
	end

end

function mundo:draw()
	local jx,jy,jl,ja=jogador.x,jogador.y,img_jogador[jogador.frame]:getWidth(),img_jogador[jogador.frame]:getHeight()
	local mx,my,ml,ma=0,0,0,0
	local c=0
	jogador.mundo_escorrega=0
	for i,m in ipairs(mundo) do
		if m.nome_img=="img_ceu" then
			love.graphics.setColor(255,255,255,255)
			love.graphics.draw(img_ceu,m.x,m.y,0,10000,1)
		else
			if m.nome_img~="limite" then
				if (m.x>=-80 and m.x+m.img:getWidth()<=res_x+80) then
					if m.nome_img=="plank" then
						if m.tipo=="vert" then
							if m.dir=="down" then
								if math.abs(m.y-m.ini_y)<200 then
									m.y=m.y+.25
									if jogador.objeto_colisao=="plank_vert" then
										jogador.y=jogador.y+.25
										d=jogador.y+img_jogador[jogador.frame]:getHeight()-m.y
										if d>0 then
											jogador.y=jogador.y-d
										end
									end
								else
									m.dir="up"
								end
							elseif m.dir=="up" then
								if math.abs(m.y-m.ini_y)>0 then
									m.y=m.y-.25
									if jogador.objeto_colisao=="plank_vert" then
										jogador.y=jogador.y-.25
										d=jogador.y+img_jogador[jogador.frame]:getHeight()-m.y
										if d>0 then
											jogador.y=jogador.y-d
										end
									end
								else
									m.dir="down"
								end
							end
						end
					end
					if string.find(m.nome_img,"cloud")~=nil then
						m.x=m.x+m.vel_x
						if m.vel_x<0 and m.x+m.img:getWidth()<self[1].x then
							m.x=self[#self].x+80
							m.y=math.random(self[1].y,self[1].y+150)
						end
						if m.vel_x>0 and m.x>self[#self].x+80 then
							m.x=self[1].x-(m.img:getWidth()+10)
							m.y=math.random(self[1].y,self[1].y+150)
						end
					end
					if m.nome_img=="bonus" then
						if m.tipo=="hit_up" then
							if math.abs(m.y-m.ini_y)<50 then
								m.y=m.y-2
							else
								m.tipo="hit_down"
								m.img=love.graphics.newImage("gfx/bonus_used.png")
								if m.cor=="" then
									for j=1,10 do
										dir=math.random(-1,1)
										if dir==0 then dir=1 end
										vx=math.random(1,4)*dir
										vy=math.random(3,8)
										moeda:add(m.x+(m.img:getWidth()/2),m.y-40,math.random(1,3),vx,vy,dir)
									end
								else
									chave:add(m.x+5,m.y-40,m.cor)
								end
							end
						end
						if m.tipo=="hit_down" then
							if math.abs(m.y-m.ini_y)>0 then
								m.y=m.y+2
							else
								m.tipo="used"
							end
						end
					end

					if m.nome_img=="base" then
						if math.abs(jogador.x-m.x)<=400 and math.abs(jogador.y-m.y)<=400 then
							inimigo:cria_tiro(i)
						end
					end

					if m.nome_img=="ballon" then
						if m.explodido==false then
							if love.timer.getMicroTime()>=m.tempo_treme then
								if m.dir=="esq" then
									if m.x-m.ini_x>-6 then
										m.x=m.x-m.vel_x
									else
										m.dir="dir"
									end
								else
									if m.x-m.ini_x<6 then
										m.x=m.x+m.vel_x
									else
										m.dir="esq"
									end
								end
								m.vel_x=m.vel_x+.025
								if love.timer.getMicroTime()>=m.tempo_treme+1.5 then
									m.tempo_explosao=love.timer.getMicroTime()
									m.explodido=true
									m.tempo_cria_efeito=love.timer.getMicroTime()
								end
							end
						end
						if m.explodido==true and love.timer.getMicroTime()>=m.tempo_cria_efeito+.025 then
							if m.qtd_explosao<4 then
								m.qtd_explosao=m.qtd_explosao+1
								m.tempo_cria_efeito=love.timer.getMicroTime()
								efeito:add(math.random(m.x-10,m.x+23),math.random(m.y-10,m.y+30),"sparkle_ballon","")
							end
						end
					end

					if m.nome_img=="limite" then m.exibe=4 end
					if m.exibe<4 then
						if math.abs(jogador.x-m.x)<=200 and math.abs(jogador.y-m.y)<=200 then
							if m.exibe<4 then m.exibe=4 end
						elseif math.abs(jogador.x-m.x)<=250 and math.abs(jogador.y-m.y)<=250 then
							if m.exibe<3 then m.exibe=3 end
						elseif math.abs(jogador.x-m.x)<=300 and math.abs(jogador.y-m.y)<=300 then
							if m.exibe<2 then m.exibe=2 end
						elseif math.abs(jogador.x-m.x)<=350 and math.abs(jogador.y-m.y)<=350 then
							if m.exibe==0 then m.exibe=1 end
						end
					end
					if m.exibe>0 then
						if m.exibe==1 then
							alpha=80
						elseif m.exibe==2 then
							alpha=140
						elseif m.exibe==3 then
							alpha=190
						elseif m.exibe==4 then
							alpha=255
						end
						if m.nome_img~="ballon" and m.nome_img~="lock" then
							love.graphics.setColor(alpha,alpha,alpha,alpha)
							love.graphics.draw(m.img,m.x,m.y)
						else
							if m.nome_img=="ballon" then
								if m.explodido==false then
									love.graphics.setColor(alpha,alpha,alpha,alpha)
									love.graphics.draw(m.img,m.x,m.y)
								else
									if love.timer.getMicroTime()>=m.tempo_explosao+5 then
										mx,my,ml,ma=m.x,m.y,m.img:getWidth(),m.img:getHeight()
										if not checa_colisao(jx,jy,jl,ja,mx,my,ml,ma) then
											m.vel_x=.0025
											m.colisao=false
											m.explodido=false
											m.tempo_treme=0
											m.tempo_explosao=0
											m.x=m.ini_x
											m.qtd_explosao=0
											if m.cor=="green" then
												m.tempo_treme=love.timer.getMicroTime()+2.5
											elseif m.cor=="blue" then
												m.tempo_treme=love.timer.getMicroTime()+2
											elseif m.cor=="yellow" then
												m.tempo_treme=love.timer.getMicroTime()+1.5
											elseif m.cor=="red" then
												m.tempo_treme=love.timer.getMicroTime()+1
											end
										end
									end
								end
							elseif m.nome_img=="lock" then
								alfa=alpha
								if m.explodido==true then alfa=0 end
								love.graphics.setColor(alfa,alfa,alfa,alfa)
								love.graphics.draw(m.img,m.x,m.y)
							end
						end
					end
					if m.colisao_jogador==true then
						c=c+1
						jogador.mundo_escorrega=i
					end
					if m.colisao_moeda==true then
						cm=cm+1
					end
				end
			end
		end
	end
	if c>1 then
		jogador.mundo_escorrega=0
		jogador.vel_x=0
	end
end

function mundo:testa_colisao_jogador(jx,jy)
	local jl,ja=img_jogador[jogador.frame]:getWidth(),img_jogador[jogador.frame]:getHeight()
	local ml,ma,x=0,0,0

	jogador.colisao=false

	jogador.objeto_colisao=""

	if jogador.vivo==false or jogador.afundando==true then
		return
	end

	for i,m in ipairs(mundo) do
		m.colisao_jogador=false
		if m.nome_img~="limite" and m.nome_img~="img_ceu" then
			if (m.x>=0 and m.x+m.img:getWidth()<=res_x) then
				mx,my,ml,ma=m.x,m.y,m.img:getWidth(),m.img:getHeight()
				if m.nome_img=="ballon" and m.tempo_treme>0 then mx,ml=mx-6,ml+6 end
				if m.nome_img=="base" or string.find(m.nome_img,"ground")~=nil or m.nome_img=="bridge" or string.find(m.nome_img,"bonus")~=nil or m.nome_img=="plank" or m.nome_img=="crate" or string.find(m.nome_img,"spikes")~=nil or string.find(m.nome_img,"water")~=nil or (m.nome_img=="ballon" and m.explodido==false) or (m.nome_img=="lock" and m.explodido==false) then
					if checa_colisao(jx,jy,jl,ja,mx,my,ml,ma) then
						m.colisao_jogador=true
						jogador.colisao=true
						jogador.posicao_colisao="on_top"
						if string.find(m.nome_img,"water")~=nil then
							jogador.direcao=""
							jogador.colisao=false
							jogador.afundando=true
							jogador.tempo_afundando=love.timer.getMicroTime()
							jogador.frame=22
							for i=1,6 do
								efeito:add(math.random(jx-10,jx+10),m.y-10,"bubbles",-1)
							end
							for i=1,6 do
								efeito:add(math.random(jx+jl-10,jx+jl+10),m.y-10,"bubbles",1)
							end
							return
						end
						if jogador.y>m.y+ma then
							jogador.posicao_colisao="on_bottom"
							if m.nome_img=="spikes_down" and jogador.atingido==false then
								jogador.frame=22
								if (jogador.moeda_ouro+jogador.moeda_prata+jogador.moeda_bronze)==0 then
									jogador.direcao=""
									jogador.colisao=false
									jogador.vivo=false
									jogador.vel_y=-16
									return
								else
									jogador.atingido=true
									jogador.tempo_atingido=love.timer.getMicroTime()
									moeda:libera_moeda()
								end
							end
						end
						if m.nome_img=="spikes" and jogador.atingido==false then
							if jogador.y+img_jogador[jogador.frame]:getHeight()<=m.y then
								jogador.frame=22
								if (jogador.moeda_ouro+jogador.moeda_prata+jogador.moeda_bronze)==0 then
									jogador.direcao=""
									jogador.colisao=false
									jogador.vivo=false
									jogador.vel_y=-16
									return
								else
									jogador.colisao=false
									jogador.atingido=true
									jogador.tempo_atingido=love.timer.getMicroTime()
									jogador.direcao="left"
									jogador.vel_y=-16
									moeda:libera_moeda()
								end
							end
						end
						if jogador.posicao_colisao=="on_top" and m.nome_img=="bridge" then
							if math.abs(m.y-m.ini_y)<=5 then
								m.y=m.y+1
							end
						end
						if jogador.posicao_colisao=="on_bottom" and m.nome_img=="bonus" and m.tipo=="" then
							m.tipo="hit_up"
						end
						if m.nome_img=="plank" then
							jogador.objeto_colisao="plank_"..m.tipo
						end
					else
						if math.abs(m.y-m.ini_y)>0 and m.nome_img=="bridge" then
							m.y=m.y-1
						end
					end
				end
			end
		end
	end

end

function mundo:trata_crate_lock()

	local jx,jy,jl,ja=jogador.x,jogador.y,img_jogador[jogador.frame]:getWidth(),img_jogador[jogador.frame]:getHeight()
	local ml,ma=0,0

	vx=0
	if jogador.direcao=="right" then
		vx=4
	elseif jogador.direcao=="left" then
		vx=-4
	end

	for i,m in ipairs(mundo) do
		if m.nome_img=="crate" or (m.nome_img=="lock" and m.explodido==false) then
			if (m.x>=0 and m.x+m.img:getWidth()<=res_x) or (m.y>=0 and m.y+m.img:getHeight()<=res_y) then
				ml=m.img:getWidth()
				ma=m.img:getHeight()
				if checa_colisao(jx+vx,jy,jl,ja,m.x,m.y,ml,ma) then
					if jx+jl<m.x or jx>=m.x+ml then
						if m.nome_img=="crate" then
							jogador.colisao=false
							if jx+jl<m.x then
								x=4
							elseif jx>=m.x+ml then
								x=-4
							end
							if mundo:testa_colisao_crate(i,x) then
								jogador.x=jogador.x+(vx*-1)
							else
								m.x=m.x+x
							end
						elseif m.nome_img=="lock" and m.explodido==false then
							jogador.colisao=true
							if jx+jl<m.x or jx>=m.x+ml then
								if jogador.chave_verde==true and m.cor=="green" then
									mundo[i].explodido=true
									jogador.chave_verde=false
								elseif jogador.chave_azul==true and m.cor=="blue" then
									mundo[i].explodido=true
									jogador.chave_azul=false
								elseif jogador.chave_vermelha==true and m.cor=="red" then
									mundo[i].explodido=true
									jogador.chave_vermelha=false
								elseif jogador.chave_amarela==true and m.cor=="yellow" then
									mundo[i].explodido=true
									jogador.chave_amarela=false
								end
								if m.explodido==true then
									for i=1,5 do
										efeito:add(math.random(m.x-10,m.x+50),math.random(m.y-10,m.y+50),"estrela_lock",m.cor)
									end
									x=(m.x+(m.img:getWidth()/2))-11
									y=(m.y+(m.img:getHeight()/2))-22
									diamante:add(x,y,0)
								end
							end
						end
					end
				end
			end
		end
	end
end

function mundo:testa_colisao_crate(cr,vx)
	local crl,cra=mundo[cr].img:getWidth(),mundo[cr].img:getHeight()
	local crx=mundo[cr].x+vx
	local cry=mundo[cr].y
	local ml,ma=0,0

	for i,m in ipairs(mundo) do
		if i~=cr and m.nome_img~="limite" and m.nome_img~="img_ceu" then
			if (m.x>=-80 and m.x+m.img:getWidth()<=res_x+80) then
				if (m.nome_img=="base" or string.find(m.nome_img,"ground")~=nil or m.nome_img=="bridge" or string.find(m.nome_img,"bonus")~=nil or m.nome_img=="plank" or m.nome_img=="crate" or string.find(m.nome_img,"spikes")~=nil) or m.nome_img=="ballon" or (m.nome_img=="lock" and m.explodido==false) then
					ml=m.img:getWidth()
					ma=m.img:getHeight()
					if checa_colisao(crx,cry,crl,cra,m.x,m.y,ml,ma) then
						return true
					end
				end
			end
		end
	end
	return false
end

function mundo:testa_colisao_moeda(mo)
	local mol,moa=moeda[mo].img:getWidth(),moeda[mo].img:getHeight()
	local mox=moeda[mo].x+moeda[mo].vel_x
	local moy=moeda[mo].y+moeda[mo].vel_y
	local ml,ma=0,0

	for i,m in ipairs(mundo) do
		if m.nome_img~="limite" and m.nome_img~="img_ceu" then
			if (m.x>=-80 and m.x+m.img:getWidth()<=res_x+80) then
				if m.nome_img=="base" or string.find(m.nome_img,"ground")~=nil or m.nome_img=="bridge" or string.find(m.nome_img,"bonus")~=nil or m.nome_img=="plank" or m.nome_img=="crate" or string.find(m.nome_img,"spikes")~=nil or m.nome_img=="ballon" or m.nome_img=="lock" then
					ml=m.img:getWidth()
					ma=m.img:getHeight()
					if (m.x+ml>=0 and m.x<=res_x) or (m.y+ma>=0 and m.y<=res_y) then
						if checa_colisao(mox,moy,mol,moa,m.x,m.y,ml,ma) then
							if moeda[mo].x+moeda[mo].img:getWidth()<m.x or moeda[mo].x>m.x+m.img:getWidth() then
								moeda[mo].vel_x=moeda[mo].vel_x*-1
							else
								moeda[mo].colisao=true
							end
						end
					end
				end
			end
		end
	end
end

function mundo:testa_colisao_inimigo(f)
	local fl,fa=inimigo[f].img:getWidth(),inimigo[f].img:getHeight()
	local fx=inimigo[f].x+inimigo[f].vel_x
	local fy=inimigo[f].y+inimigo[f].vel_y
	local ml,ma=0,0

	for i,m in ipairs(mundo) do
		if m.nome_img~="limite" and m.nome_img~="img_ceu" then
			if (m.x>=-80 and m.x+m.img:getWidth()<=res_x+80) then
				if string.find(m.nome_img,"ground")~=nil or m.nome_img=="bridge" or string.find(m.nome_img,"bonus")~=nil or m.nome_img=="plank" or m.nome_img=="crate" or string.find(m.nome_img,"spikes")~=nil or string.find(m.nome_img,"water")~=nil or m.nome_img=="ballon" or m.nome_img=="lock" then
					ml=m.img:getWidth()
					ma=m.img:getHeight()
					if (m.x+ml>=0 and m.x<=res_x) or (m.y+ma>=0 and m.y<=res_y) then
						if checa_colisao(fx,fy,fl,fa,m.x,m.y,ml,ma) then
							inimigo[f].colisao=true
						end
					end
				end
			end
		end
	end
end


function mundo:atualiza_posicao_x()
	for i,m in ipairs(mundo) do
		if string.find(jogador.direcao,"right")~=nil then
			m.x=m.x-4
			m.ini_x=m.ini_x-4
		elseif string.find(jogador.direcao,"left")~=nil then
			m.x=m.x+4
			m.ini_x=m.ini_x+4
		end
	end
end

function mundo:reset()
	local x,y=0,320
	self:add(0,0,"limite","","")

	self:add(0,0,"img_ceu","","")
	for i=1,10 do
		self:add(math.random(4000),math.random(150),"cloud_"..(math.random(1,3)),"")
	end


	self:add(250,200,"ground","","")
	self:add(x,500,"ground","","")
	x=x+self[#self].img:getWidth()
	self:add(x,500,"ground","","")
	x=x+self[#self].img:getWidth()
	self:add(x,430,"ground","","")
	x=x+self[#self].img:getWidth()
	for i=4,45 do
		a="ground"
		if i==45 then a=a.."_dirt" end
		self:add(x,y,a,"")
		if i==10 then
			self:add(x+70,y+190,"ground","","")
			self:add(x+140,y+190,"ground","","")
			self:add(x+210,y+190,"ground","","")
			x=x+140
		end
		x=x+self[#self].img:getWidth()
	end

	self:add(1680,y-70,"crate","","")
    self:add(x-70,y-70,"ground","","")

	self:add(470,650,"ground","","")
	self:add(540,650,"ground","","")
	self:add(970,700,"ground","","")
	self:add(1040,700,"ground","","")
	self:add(1250,700,"ground","","")
	self:add(1320,700,"ground","","")
	self:add(1520,700,"ground","","")
	self:add(1590,700,"ground","","")
	self:add(1660,700,"ground","","")
	self:add(1730,700,"ground","","")
	self:add(800,800,"ground","","")
	self:add(730,800,"ground","","")

	self:add(1420,800,"plank","vert","")

	self:add(950,220,"ground","","")
	self:add(1300,220,"ground","","")
	for i=1,4 do
		self:add(950+(70*i),220,"bridge","","")
	end

	x,y=1730,600
	for i=1,50 do
		x=x+70
		self:add(x,y,"ground","","")
		if i>3 and i<9 then
			y=y+60
		end
		if i>9 and i<15 then
			y=y-60
		end
	end

	self:add(x-1400,y-220,"bonus","","")
	self:add(450,100,"bonus","","red")
	self:add(x-1000,y-220,"bonus","","yellow")
	self:add(180,730,"bonus","","blue")
	self:add(100,1000,"ground","","")
	self:add(170,1000,"ground","","")
	self:add(240,1000,"ground","","")
	self:add(310,930,"ground","","")
	self:add(380,860,"ground","","")

	self:add(511,390,"spikes_down","down","")
	self:add(1668,665,"spikes","up","")

	self:add(3000,y-16,"base","","")

	self:add(1110,725,"water","","")
	self:add(1180,725,"water","","")
	y=770
	for i=1,10 do
		self:add(1110,y,"deep_water","","")
		self:add(1180,y,"deep_water","","")
		y=y+70
		if y>res_y then break end
	end

	self:add(2680,250,"lock","","red")

	self:add(2000,100,"ballon","esq","green")
	self:add(2200,100,"ballon","esq","red")


	self:add(x,900,"limite","","")
end
